import request from '~/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { UserCollection, UserCollectionParam } from './model';
import { SERVER_API_URL } from '@/config';

/**
 * 分页查询我的收藏
 */
export async function pageUserCollection(params: UserCollectionParam) {
  const res = await request.get<ApiResult<PageResult<UserCollection>>>(
    SERVER_API_URL + '/system/user-collection/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询我的收藏列表
 */
export async function listUserCollection(params?: UserCollectionParam) {
  const res = await request.get<ApiResult<UserCollection[]>>(
    SERVER_API_URL + '/system/user-collection',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加我的收藏
 */
export async function addUserCollection(data: UserCollection) {
  const res = await request.post<ApiResult<unknown>>(
    SERVER_API_URL + '/system/user-collection',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改我的收藏
 */
export async function updateUserCollection(data: UserCollection) {
  const res = await request.put<ApiResult<unknown>>(
    SERVER_API_URL + '/system/user-collection',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除我的收藏
 */
export async function removeUserCollection(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    SERVER_API_URL + '/system/user-collection/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除我的收藏
 */
export async function removeBatchUserCollection(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    SERVER_API_URL + '/system/user-collection/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询我的收藏
 */
export async function getUserCollection(id: number) {
  const res = await request.get<ApiResult<UserCollection>>(
    SERVER_API_URL + '/system/user-collection/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
